Subject: Re: [PATCH 02/19] global: assign non-const strings as required

From: Junio C Hamano <[email-masked]>
Date: Wed, 05 Jun 2024 10:13:28 -0700

Jeff King <[email-masked]> writes:

> On Fri, May 31, 2024 at 08:27:13AM -0700, Junio C Hamano wrote:
>
>> I wonder if we can do something to separate these two concerns
>> apart, using a trick similar to what we often use with an extra
>> variable "to_free".  Doing so would bloat the refspec_item, but
>> unlike the references themselves, there won't be thousands of them,
>> so it may not be an issue, perhaps?
>
> I had a similar thought while looking at this spot a while ago, so I dug
> this attempt out of my stash. It's quite ugly, as you need to keep the
> storage pointer and the const pointer in sync. Especially because
> there's a lot of clever pointer indirection via match_name_with_pattern().

Ah, true.  The patch itself does not look _too_ bad, but that may
simply be because the original is bad enough ;-)